---not edit script---

guiSetGet = {};

function guiSetGet:defaultValues(self)	
	g_currentMission.guiMenue.default = {
		errorCmdTxt = "Cmd Not Found";
		buttonGfxWidth1 = guiSetGet:pxToNormal(1, 'x', false);
		buttonGfxHeight1  = guiSetGet:pxToNormal(1, 'y', false);
		posX = 0.14;
		posY = 0.6;		
		zoomHorizontal = 5;
		zoomVertical = 5;
		zoomOutInTemp = 3.4;
		zoomOutInLevel = 0.1;
		maxZoomOutInTemp = 4.5;
		minZoomOutInTemp = 2.5;
		--iconHeight = guiSetGet:pxToNormal(1, 'y', false)*30;
		--iconWidth = guiSetGet:pxToNormal(1, 'x', false)*31;
		width = guiSetGet:pxToNormal(1, 'x', false)*600;
		height = guiSetGet:pxToNormal(1, 'y', false)*80;	
		textColor = guiSetGet.colors["white"];
		textTitleColor = guiSetGet.colors["ls15Disabled"];
		textTitleModColor = guiSetGet.colors["hover"];
		--textWarningColor = guiSetGet.colors["red"];		
		groundColor = guiSetGet.colors["blackDisabled"];
		buttonGroundColor = guiSetGet.colors["grayInactive"];
		lineBorderColor = guiSetGet.colors["ls15Disabled"];
		lineBorderModColor = guiSetGet.colors["hover"];
		textTurnSideColor = guiSetGet.colors["yellow"];
		groundTurnSideColor = guiSetGet.colors["grayInactive"];
		groundLineColor = guiSetGet.colors["white"];
		groundPullDownColor = guiSetGet.colors["white"];
		groundSlideButtonColor = guiSetGet.colors["black"];
		groundSlideRegulatorColor = guiSetGet.colors["white"];
		minSlideRegulator = 0.003;
		
		groundPushButtonColor = guiSetGet.colors["white"];
		buttonTypeColor = guiSetGet.colors["black"];
		
		--markerColor = guiSetGet.colors["yellow"];
		helpTextColor = guiSetGet.colors["black"];
		helpGroundColor = guiSetGet.colors["white"];
		infoTextColor = guiSetGet.colors["yellow"];
		pullDownTextColor = guiSetGet.colors["black"];
		pullDownTextSelectActiveColor = guiSetGet.colors["darkGreen"];
		pullDownTextNotActiveColor = guiSetGet.colors["red"];		
		--infoTextSize = 0.010;
		--helpTextSize = 0.010;
		size = 0.010;
		horizontalTxtDistance = 0.001;
		verticalTxtDistance = 0.001;
		buttonType = {"buttonUp", "buttonDown", "buttonUpDown", "buttonLeft", "buttonRight", "buttonLeftRight", "buttonOnOff", "buttonEmpty"};
		
	};
	--if g_screenWidth > 1920 then
	--	width = guiSetGet:pxToNormal(1, 'x', false)*(g_screenWidth/2.3);
	--	height = guiSetGet:pxToNormal(1, 'y', false)*(g_screenWidth/2.3);
	--end;
	guiSetGet.iconSize = {
		m1x128   		= { 512, 2048 }; --Orginal Bildgröße x128
		m4x64   		= { 256, 2048 }; --x16
		m6x32   		= { 128, 256 }; --x8
		ls256   		= { 256, 256 }; --x8
		zoomToleranz	= { 0.005, 0.01 }; --zoom Toleranz
	};
	guiSetGet.icon = {		
		groundMaster   	= { 0+0.3, 128*1-96-0.3, 32-0.3, 0+0.3};
		buttonType1		= { 32+0.3, 128*1-96-0.3, 64-0.3, 0+0.3};
		buttonType2		= { 64+0.3, 128*1-96-0.3, 96-0.3, 0+0.3};
		buttonType3		= { 96+0.3, 128*1-96-0.3, 128-0.3, 0+0.3};
		buttonZoomIn	= { 128+0.3, 128*1-96-0.3, 160-0.3, 0+0.3};
		buttonZoomOut	= { 160+0.3, 128*1-96-0.3, 192-0.3, 0+0.3};
		buttonDragDrop	= { 0+0.3, 128*1-64-0.3, 32-0.3, 0+32+0.3};
		buttonClose		= { 32+0.3, 128*1-64-0.3, 64-0.3, 0+32+0.3};
		buttonSave		= { 64+0.3, 128*1-64-0.3, 96-0.3, 0+32+0.3};
		buttonHelp		= { 96+0.3, 128*1-64-0.3, 128-0.3, 0+32+0.3};
		buttonSmallView = { 128+0.3, 128*1-64-0.3, 160-0.3, 0+32+0.3};
		
		guiLineT     	= { 0+0.1, 128*2-0.1, 8-0.1, 128+112+0.1};
		--guiGround    	= { 32+1, 128*2-1, 64-1, 128+96+1};
		guiLine      	= { 8+0.1, 128*2-0.1, 16-0.1, 128+112+0.1};		
		
		settings   	   	= { 0+0.1, 128*1-0.1-96, 32-0.1, 0+0.1};
		roundRight     	= { 32+0.1, 128*1-0.1-96, 64-0.1, 0+0.1};
		roundMultiple 	= { 64+0.1, 128*1-0.1-96, 96-0.1, 0+0.1};
		roundLeft      	= { 96+0.1, 128*1-0.1-96, 128-0.1, 0+0.1};
		
		halfRoundLeft  	= { 0+0.1, 128*1-0.1-64, 32-0.1, 0+32+0.1};
		halfRoundRight 	= { 32+0.1, 128*1-0.1-64, 64-0.1, 0+32+0.1};
		arrowLeft      	= { 64+0.1, 128*1-0.1-64, 96-0.1, 0+32+0.1};
		arrowRight     	= { 96+0.1, 128*1-0.1-64, 128-0.1, 0+32+0.1};
		
		okay           	= { 0+0.1, 128*1-0.1-32, 32-0.1, 0+64+0.1};
		notOkay        	= { 32+0.1, 128*1-0.1-32, 64-0.1, 0+64+0.1};
		notReady       	= { 64+0.1, 128*1-0.1-32, 96-0.1, 0+64+0.1};
		saveButton		= { 96+0.1, 128*1-0.1-32, 128-0.1, 0+64+0.1};
		
		infoText       	= { 0+0.1, 128*1-0.1, 32-0.1, 0+96+0.1};
		roundButton		= { 32+0.1, 128*1-0.1, 64-0.1, 0+96+0.1};
		arrowUp		    = { 64+0.1, 128*1-0.1, 96-0.1, 0+96+0.1};
		arrowDown		= { 96+0.1, 128*1-0.1, 128-0.1, 0+96+0.1};		
	};	
	guiSetGet:reloadMenueImages(self, false);
end;

function guiSetGet:mulitOverlayTest()
end;

function guiSetGet:setOptiWidthHeight(self)	
	g_currentMission.guiMenue.default.height = (g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical)*6.5; --old 5
	g_currentMission.guiMenue.default.width = (g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal)*25;	
end;

function guiSetGet:optiWidthSize(self, width, txtString, defaultSize)
		
end;

function guiSetGet:txtLineBounds(self, txtString, defaultSize, maxTxtWidth, timer)
	local foundLineBounds = math.ceil(getTextWidth(defaultSize, txtString)/maxTxtWidth); --getTextLength(optiSize, txt, 2);
	local beginLine, endLine = 0,0;
	if foundLineBounds > 2 then
		g_currentMission.guiMenue.infoText.timer = g_currentMission.guiMenue.infoText.timer+1;
		if g_currentMission.guiMenue.infoText.timer >= timer then
			g_currentMission.guiMenue.infoText.timer = 0;
			if g_currentMission.guiMenue.infoText.lineBounds+2 > foundLineBounds then 
				g_currentMission.guiMenue.infoText.lineBounds = 0;				
			else
				g_currentMission.guiMenue.infoText.lineBounds = g_currentMission.guiMenue.infoText.lineBounds+2;
			end;
		end;
		beginLine = g_currentMission.guiMenue.infoText.lineBounds;
		endLine = g_currentMission.guiMenue.infoText.lineBounds+2;
		--setTextLineBounds(g_currentMission.guiMenue.infoText.lineBounds, g_currentMission.guiMenue.infoText.lineBounds+2);
	end;
	return beginLine, endLine;
end;

function guiSetGet:optiHeightSize(self, height, txtString, defaultSize, setSize)
	local txtHeight = getTextHeight(defaultSize, tostring(txtString));
	local default = defaultSize;
	if txtHeight > height then
		local i = 0;
		while txtHeight > height do
			i = i + 0.0005;
			txtHeight = getTextHeight(defaultSize-i, tostring(txtString));
		end
		if setSize == nil or not setSize then return defaultSize-i;else g_currentMission.guiMenue.default.size = defaultSize-i;end;
	elseif setSize then
		if txtHeight < height then
			local i = 0;
			while txtHeight < height do
				i = i + 0.0005;
				txtHeight = getTextHeight(defaultSize+i, tostring(txtString));
			end
			if setSize == nil or not setSize then return defaultSize+i;else g_currentMission.guiMenue.default.size = defaultSize+i;end;
		end;
	end;
	if setSize == nil or not setSize then return default;end;
end;

function guiSetGet:loadMenueImages(self, reload)
	local iconFilePath = guiSetGet:checkDesignFilePath();
	if iconFilePath == nil then return;end;	
	if reload then guiSetGet:deleteMenueImages();end;
	local overlay = g_currentMission.guiMenue.overlays;
	overlay["groundMaster"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.width, g_currentMission.guiMenue.default.height, 'groundMaster');
	guiSetGet:setOverlayUVsPx(overlay["groundMaster"], guiSetGet.icon["groundMaster"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["groundMaster"], g_currentMission.guiMenue.default.groundColor);
	
	overlay["groundSlave"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.width, g_currentMission.guiMenue.default.height*3.1);
	guiSetGet:setOverlayUVsPx(overlay["groundSlave"], guiSetGet.icon["groundMaster"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["groundSlave"], g_currentMission.guiMenue.default.groundColor);
	
	overlay["groundHelpTxt"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["groundHelpTxt"], guiSetGet.icon["groundMaster"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["groundHelpTxt"], g_currentMission.guiMenue.default.helpGroundColor);
	
	overlay["groundPushButton"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["groundPushButton"], guiSetGet.icon["groundMaster"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["groundPushButton"], g_currentMission.guiMenue.default.groundPushButtonColor);
	
	overlay["groundSlideButton"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["groundSlideButton"], guiSetGet.icon["groundMaster"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["groundSlideButton"], g_currentMission.guiMenue.default.groundSlideButtonColor);
	
	overlay["buttonSlideRegulator"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonSlideRegulator"], guiSetGet.icon["groundMaster"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonSlideRegulator"], g_currentMission.guiMenue.default.groundSlideButtonColor);
	
	overlay["buttonUpDown"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonUpDown"], guiSetGet.icon["buttonType1"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonUpDown"], g_currentMission.guiMenue.default.buttonTypeColor);
	
	overlay["buttonUp"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonUp"], guiSetGet.icon["buttonType2"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonUp"], g_currentMission.guiMenue.default.buttonTypeColor);
	overlay["buttonDown"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonDown"], guiSetGet.icon["buttonType2"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonDown"], g_currentMission.guiMenue.default.buttonTypeColor);
	setOverlayRotation(overlay["buttonDown"].overlayId, 3.141592653589793, 0+(overlay["buttonDown"].width/2), 0+(overlay["buttonDown"].height/2));

	overlay["buttonSlideUp"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomVertical/2));
	guiSetGet:setOverlayUVsPx(overlay["buttonSlideUp"], guiSetGet.icon["buttonType2"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonSlideUp"], g_currentMission.guiMenue.default.buttonTypeColor);
	overlay["buttonSlideDown"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomVertical/2));
	guiSetGet:setOverlayUVsPx(overlay["buttonSlideDown"], guiSetGet.icon["buttonType2"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonSlideDown"], g_currentMission.guiMenue.default.buttonTypeColor);
	setOverlayRotation(overlay["buttonSlideDown"].overlayId, 3.141592653589793, 0+(overlay["buttonSlideDown"].width/2), 0+(overlay["buttonSlideDown"].height/2));
		
	overlay["buttonLeftRight"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonLeftRight"], guiSetGet.icon["buttonType1"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonLeftRight"], g_currentMission.guiMenue.default.buttonTypeColor);
	setOverlayRotation(overlay["buttonLeftRight"].overlayId, 1.5707963267948966, 0+(overlay["buttonLeftRight"].width/2), 0+(overlay["buttonLeftRight"].height/2));
		
	overlay["buttonLeft"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonLeft"], guiSetGet.icon["buttonType2"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonLeft"], g_currentMission.guiMenue.default.buttonTypeColor);
	setOverlayRotation(overlay["buttonLeft"].overlayId, 1.5707963267948966, 0+(overlay["buttonLeft"].width/2), 0+(overlay["buttonLeft"].height/2));
	
	overlay["buttonSlideLeft"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomHorizontal/2), g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonSlideLeft"], guiSetGet.icon["buttonType2"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonSlideLeft"], g_currentMission.guiMenue.default.buttonTypeColor);
	setOverlayRotation(overlay["buttonSlideLeft"].overlayId, 1.5707963267948966, 0+(overlay["buttonSlideLeft"].width/2), 0+(overlay["buttonSlideLeft"].height/2));
		
	overlay["buttonRight"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonRight"], guiSetGet.icon["buttonType2"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonRight"], g_currentMission.guiMenue.default.buttonTypeColor);
	setOverlayRotation(overlay["buttonRight"].overlayId, -1.5707963267948966, 0+(overlay["buttonRight"].width/2), 0+(overlay["buttonRight"].height/2));
	
	overlay["buttonSlideRight"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomHorizontal/2), g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonSlideRight"], guiSetGet.icon["buttonType2"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonSlideRight"], g_currentMission.guiMenue.default.buttonTypeColor);
	setOverlayRotation(overlay["buttonSlideRight"].overlayId, -1.5707963267948966, 0+(overlay["buttonSlideRight"].width/2), 0+(overlay["buttonSlideRight"].height/2));
		
	overlay["buttonOnOff"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonOnOff"], guiSetGet.icon["buttonType3"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);	
	
	overlay["buttonEmpty"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonEmpty"], guiSetGet.icon["buttonType3"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonEmpty"], g_currentMission.guiMenue.default.buttonGroundColor);
		
	overlay["groundPullDown"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.width/2, g_currentMission.guiMenue.default.height*2);
	guiSetGet:setOverlayUVsPx(overlay["groundPullDown"], guiSetGet.icon["groundMaster"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["groundPullDown"], g_currentMission.guiMenue.default.groundPullDownColor);

	overlay["groundInfoBox"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.width, g_currentMission.guiMenue.default.height/1.5);
	guiSetGet:setOverlayUVsPx(overlay["groundInfoBox"], guiSetGet.icon["groundMaster"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["groundInfoBox"], g_currentMission.guiMenue.default.groundColor);

	
	overlay["buttonBlank"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonBlank"], guiSetGet.icon["groundMaster"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonBlank"], g_currentMission.guiMenue.default.buttonGroundColor);
	overlay["buttonDragDrop"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonDragDrop"], guiSetGet.icon["buttonDragDrop"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	overlay["lineBorder"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*1, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*1);
	guiSetGet:setOverlayUVsPx(overlay["lineBorder"], guiSetGet.icon["groundMaster"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["lineBorder"], g_currentMission.guiMenue.default.lineBorderColor);
		
	overlay["buttonSave"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonSave"], guiSetGet.icon["buttonSave"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonSave"], guiSetGet.colors["green"]);
	overlay["buttonClose"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomHorizontal, g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical);
	guiSetGet:setOverlayUVsPx(overlay["buttonClose"], guiSetGet.icon["buttonClose"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonClose"], guiSetGet.colors["red"]);
	overlay["buttonHelp"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomHorizontal/2), g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomVertical/2));
	guiSetGet:setOverlayUVsPx(overlay["buttonHelp"], guiSetGet.icon["buttonHelp"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	overlay["buttonZoomIn"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomHorizontal), g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomVertical));
	guiSetGet:setOverlayUVsPx(overlay["buttonZoomIn"], guiSetGet.icon["buttonZoomIn"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonZoomIn"], guiSetGet.colors["green"]);
	overlay["buttonZoomOut"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomHorizontal), g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomVertical));
	guiSetGet:setOverlayUVsPx(overlay["buttonZoomOut"], guiSetGet.icon["buttonZoomOut"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonZoomOut"], guiSetGet.colors["green"]);
	overlay["buttonSmallView"] = Overlay:new(iconFilePath, 0, 0, g_currentMission.guiMenue.default.buttonGfxWidth1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomHorizontal), g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*(g_currentMission.guiMenue.default.zoomVertical));
	guiSetGet:setOverlayUVsPx(overlay["buttonSmallView"], guiSetGet.icon["buttonSmallView"], guiSetGet.iconSize.ls256[1], guiSetGet.iconSize.ls256[2]);
	guiSetGet:setBackgroundColor(overlay["buttonSmallView"], guiSetGet.colors["green"]);
end;

function guiSetGet:deleteMenueImages()
	if #g_currentMission.guiMenue.overlays > 0 then
		for a=1, #g_currentMission.guiMenue.overlays do
			guiSetGet:deleteOldOverlay(g_currentMission.guiMenue.overlays[a]);
		end;
	end;
end;

function guiSetGet:reloadMenueImages(self, reload)
	guiSetGet:setOptiWidthHeight(self, width, height);
	guiSetGet:loadMenueImages(self, reload);
	guiSetGet:optiHeightSize(self, (g_currentMission.guiMenue.default.buttonGfxHeight1*g_currentMission.guiMenue.default.zoomOutInTemp*g_currentMission.guiMenue.default.zoomVertical)-(g_currentMission.guiMenue.default.verticalTxtDistance*2), "Gg", g_currentMission.guiMenue.default.size, true);
end;

function guiSetGet:isOpenLsOrGuiMenueDialog()
	return (g_currentMission.guiMenue.lsOrGuiMenueDialog.isOpen and string.len(g_currentMission.guiMenue.lsOrGuiMenueDialog.name) > 0 and g_gui.currentGui ~= nil) or g_gui.currentGui ~= nil;
end;

function guiSetGet:openLsOrGuiMenueDialog(guiName, modAppValues)
	if guiName ~= nil and type(guiName) == "string" and not g_currentMission.guiMenue.guiSetGet:isOpenLsOrGuiMenueDialog() then
		if guiName == "GuiMenueInOutPutTextDialog" then
			return guiSetGet:openGuiMenueInOutPutTextDialog(modAppValues);
		elseif guiName == "LsYesNoDialog" then
			if modAppValues ~= nil and type(modAppValues) == "table" and modAppValues.onCloseCallback ~= nil and type(modAppValues.onCloseCallback) == "function" then
				g_gui:showYesNoDialog({text = modAppValues.dialogText1 or "", title = modAppValues.dialogTitel or "", callback = modAppValues.onCloseCallback, target = modAppValues.onOpenCallback or nil}); --target = open Mod/App Function (is Open Gui), onCloseCallback = close Mod/App Function (is Close Gui)
				--->reset g_currentMission.guiMenue.lsOrGuiMenueDialog... over callbackClose other next Mods not start this Dialog
				g_currentMission.guiMenue.lsOrGuiMenueDialog.isOpen = true;g_currentMission.guiMenue.lsOrGuiMenueDialog.name = "LsYesNoDialog";
				return true;
			else
				g_gui:showYesNoDialog({text = "App/Mod Value ! really delete !", title = "Gui Menue Dialog (load over App/Mod)", callback = g_currentMission.guiMenue.guiSetGet.closeLsYesNoDialog, target = nil});
				--optional check Gui open/close with Bsp: g_gui.guis["YesNoDialog"].target.isOpen ! Attention ! isOpen is only Global value
				--better check  with GuiMenue Values g_currentMission.guiMenue.lsOrGuiMenueDialog.isOpen and g_currentMission.guiMenue.lsOrGuiMenueDialog.name;
				--or guiSetGet:isOpenLsOrGuiMenueDialog() isOpen Global or GuiMenue Dialog
				--check what click Yes or No check isOpen(Dialog) and g_currentMission.guiMenue.lsOrGuiMenueDialog.yesNo == nil or true or false and then set nil for Respect or Mods/Apps check this
				g_currentMission.guiMenue.lsOrGuiMenueDialog.isOpen = true;g_currentMission.guiMenue.lsOrGuiMenueDialog.name = "LsYesNoDialog";g_currentMission.guiMenue.lsOrGuiMenueDialog.yesNo = nil;
				return true;
			end;
		end;
	end;
	return false;
end;

function guiSetGet:closeLsYesNoDialog(yes)		
	g_currentMission.guiMenue.lsOrGuiMenueDialog.isOpen = false;g_currentMission.guiMenue.lsOrGuiMenueDialog.name = "";g_currentMission.guiMenue.lsOrGuiMenueDialog.yesNo = yes;	
end;

function guiSetGet:closeLsOrGuiMenueDialog()	
	g_currentMission.guiMenue.lsOrGuiMenueDialog.isOpen = false;g_currentMission.guiMenue.lsOrGuiMenueDialog.name = "";g_currentMission.guiMenue.lsOrGuiMenueDialog.yesNo = nil;	
end;

-----------------BSP-----------------
--function guiSetGet:testClose()
--end;

--function guiSetGet:testOpen()
--end;

--return table values - inputText=Gui Input Text, helpBoxText=Gui default Text, thisGui=Gui Dialog self
--function guiSetGet.testOpen(...) <--return table
--end;
-- or
--guiSetGet.testSave = function (...) <--return table 
--	if ... ~= nil and type(...) == "table" then
--		local args = ...;--					
--		for arg,v in pairs(args) do
--			if arg == "inputText" then
--				print("Input Text ".. tostring(v))
--			end;
--		end;			
--	end;
--end;

--modAppValues = {dialogTitel="Test", dialogText1="Test 1", dialogText2="Test 2"(not for LsYesNoDialog), onCloseCallback=guiSetGet.testClose, onSaveCallback=guiSetGet.testSave, onOpenCallback=guiSetGet.testOpen, checkText=checkTextTable, visibleButton=visibleButtonTable};
--checkTextTable = {alreadyExistsTable={"Hello", "Hello Text", "Hello Your"}, inputTextAppendBegin="HUD ", inputTextAppendEnd="PDA_", alreadyExistsAllow=true, maxLengthText=10, minLengthText=3, noCharacterText='!_+-=', noCharacterTextReplace=true, unicodeText=false, helpInfoBox=false};
--visibleButtonTable = {cancelButton=false, cancelButtonText="Zurück"};
-----------------BSP-----------------

function guiSetGet:openGuiMenueInOutPutTextDialog(modAppValues)
	local self = g_GuiMenueInOutPutTextDialog;
	if self == nil then return false;end;
	guiMenueInOutPutTextDialog:setDefaultValues();	
	function is_TableEmpty(t)
		for _,_ in pairs(t) do
			return false;
		end
		return true;
	end;
	if modAppValues ~= nil and type(modAppValues) == "table" and not is_TableEmpty(modAppValues) then
		self.modAppValues = {};		
		self.modAppValues.dialogTitel = modAppValues.dialogTitel or nil; --string, default "Gui Menue Dialog (load over App/Mod)" --over Dialog Box (big size)
		self.modAppValues.dialogText1 = modAppValues.dialogText1 or nil; --string, default "max length value"(value=maxTextLength) --over inputText Box (small size)
		self.modAppValues.dialogText2 = modAppValues.dialogText2 or nil; --string, default "" --at Dialog Box (normal size)
		--...Callback and ...Disabled optional for own function, callback return a table,see ----BSP----
		self.modAppValues.onCloseCallback = modAppValues.onCloseCallback or nil; --function, onCloseGui + function App/Mod multiple
		self.modAppValues.onOpenCallback = modAppValues.onOpenCallback or nil; --function, onOpen + function App/Mod multiple
		self.modAppValues.onDrawCallback = modAppValues.onDrawCallback or nil; --function, onDraw + function App/Mod multiple
		self.modAppValues.onDrawDisabled = modAppValues.onDrawDisabled or nil; --boolean, default false, disabled Gui Menue Dialog function onDraw --> is Disabled is helpInfoBox also disabled
		self.modAppValues.keyEventCallback = modAppValues.keyEventCallback or nil; --function, keyEvent + function App/Mod multiple
		self.modAppValues.keyEventDisabled = modAppValues.keyEventDisabled or nil; --boolean, default false, disabled Gui Menue Dialog function, keyEvent
		self.modAppValues.onTextChangedCallback = modAppValues.onKeyEventCallback or nil; --function, onTextChangedCallback + function App/Mod multiple
		self.modAppValues.onSaveCallback = modAppValues.onSaveCallback or nil; --function, onClickSave + function App/Mod multiple -->return true or false (is saved) for Gui Menue Dialog and string Info Text (Bsp: return true, "Save File")
		self.modAppValues.onSaveDisabled = modAppValues.onSaveDisabled or nil; --boolean, default false, disabled Gui Menue Dialog function, onClickSave
		self.modAppValues.onCancelCallback = modAppValues.onCancelCallback or nil; --function, onClickCancel + function App/Mod multiple
		self.modAppValues.onCheckCallback = modAppValues.onCheckCallback or nil; --function, onClickCheck + function App/Mod multiple -->return true or false (is check) for Gui Menue Dialog and string Info Text (Bsp: return true, "File Check Okay")		
		self.modAppValues.onCheckDisabled = modAppValues.onCheckDisabled or nil; --boolean, default false, disabled GUI Menue Dialog function onClickCheck
		self.modAppValues.ownValues = modAppValues.ownValues; --optional for your 1:1 copy callback return
		if modAppValues.checkText ~= nil and type(modAppValues.checkText) == "table" and not is_TableEmpty(modAppValues,checkText) then --table
			self.modAppValues.checkText = {					
				inputTextAppendBegin = modAppValues.checkText.inputTextAppendBegin or nil, --string, default "", check input text with = inputTextAppendBegin.. inputText......
				inputTextAppendEnd = modAppValues.checkText.inputTextAppendEnd or nil, --string, default "", check input text with = ......inputText.. inputTextAppendEnd 
				alreadyExistsTable = modAppValues.checkText.alreadyExistsTable or nil, --string table, Bsp: {"Hello", "Hello Text", "Hello Your"}; --> better pass a parent table(uptodate table) is your onSaveCallback function insert inputText (parent table)
				alreadyExistsAllow = modAppValues.checkText.alreadyExistsAllow or nil, --boolen, default false(no check) --true = needs alreadyExistsTable (and optional checkButton = true) <-- is already exists Text then set Gui Menue Dialog helpBox Attention --> not delete input text (see checkButton))
				unicodeText = modAppValues.checkText.unicodeText, --boolen, default true, check input text
				helpInfoBox = modAppValues.checkText.helpInfoBox, --boolen, default true, set default Text at helpInfoBox
				maxLengthText = modAppValues.checkText.maxLengthText or nil, --integer, default 15, max input text
				minLengthText = modAppValues.checkText.minLengthText or nil, --integer, default 3, min input text
				noCharacterText = modAppValues.checkText.noCharacterText or nil, --string, no special character Bsp:--> ' ,_!@#$%^&*()+-={}|[]`~'; --default see guiMenueInOutPutTextDialog.noCharacterText
				noCharacterTextReplace = modAppValues.checkText.noCharacterTextReplace or nil --boolean, default false, needs noCharacterText (in combination) --default false and insert character
			};
		end;
		if modAppValues.visibleButton ~= nil and type(modAppValues.visibleButton) == "table" and not is_TableEmpty(modAppValues.visibleButton) then --table
			self.modAppValues.visibleButton = {				
				saveButton = modAppValues.visibleButton.saveButton or nil, --boolean, default false (onClickSave) --> true needs modAppValues.onSaveCallback function
				saveButtonText = modAppValues.visibleButton.saveButtonText or nil, --string, default "Save"
				noButton = modAppValues.visibleButton.noButton, --boolean, default true (onClickQuit) --> onClose
				noButtonText = modAppValues.visibleButton.noButtonText or nil, --string, default "Quit"
				yesButton = modAppValues.visibleButton.yesButton, --boolean, default true (onClickOk) --> onClose
				yesButtonText = modAppValues.visibleButton.yesButtonText or nil, --string, default LS language table
				cancelButton = modAppValues.visibleButton.cancelButton, --boolean, default true (onClickCancel) --> reset/delete text
				cancelButtonText = modAppValues.visibleButton.cancelButtonText or nil, --string, default "Cancel"				
				checkButton = modAppValues.visibleButton.checkButton, --boolean, default true(onClickCheck) --> check input text, is alreadyTextTable and alreadyText(input text) then set Gui Menue Dialog Attention and delete input text
				checkButtonText = modAppValues.visibleButton.checkButtonText or nil --string, default "Check Input"
			};
		end;
		guiMenueInOutPutTextDialog:setModAppValues();		
	else
		self.modAppValues = {};
	end;
	g_gui:showDialog("GuiMenueInOutPutTextDialog");	
	g_currentMission.guiMenue.lsOrGuiMenueDialog.isOpen = true;g_currentMission.guiMenue.lsOrGuiMenueDialog.name = "GuiMenueInOutPutTextDialog";g_currentMission.guiMenue.lsOrGuiMenueDialog.yesNo = nil;
	return true;
end;

function guiSetGet:getOverlayTableCopy(t)
	function table.copy(t)
		local t2 = {};
		for k,v in pairs(t) do
			if type(v) == "table" then
				t2[k] = table.copy(v);
			else
				t2[k] = v;
			end;
		end;
		return t2;
	end;
	return table.copy(t);
end;

function guiSetGet:getReturnClickString(buttonType, returnClickString, isUp)
	local clickString = "";
	if string.len(returnClickString) > 0 and (string.find(buttonType, "UpDown") or string.find(buttonType, "LeftRight")) then
		if isUp then			
			clickString = returnClickString.. "_Up"; 
		else			
			clickString = returnClickString.. "_Down"		
		end;
	elseif string.len(returnClickString) > 0 then
		clickString = returnClickString; --.. "_";
	end;
	return clickString;
end;

--MultiOverlayV3 only, write your own function (info under g_currentMission.guiMenue.modTable[yourModMenueTable].getButtonInfo)
function guiSetGet:getButtonInfo(...) --sort/save button list info byName(returnClick), MultiOverlayV3 Only (line,page,side,button position)
	if ... == nil or type(...) ~= "table" then return nil;end; 
	local args = ...;
	if args.modMenueTable == nil or args.name == nil or g_currentMission.guiMenue.modTable[args.modMenueTable] == nil or #g_currentMission.guiMenue.modTable[args.modMenueTable].getButtonInfo <=0 then return nil;end;
	local newTable = {};
	function setButtonInfoTable(buttonTable)
		newTable.button = buttonTable.button;
		newTable.line = buttonTable.line;
		newTable.pageSide = buttonTable.pageSide;
		newTable.page = buttonTable.page;
		newTable.pageSideGlobalName = buttonTable.pageSideGlobalName;
		newTable.pageGlobalName = buttonTable.pageGlobalName;
		newTable.masterPage = buttonTable.masterPage;
		newTable.slavePage = buttonTable.slavePage or nil;
	end;	
	for a=1, #g_currentMission.guiMenue.modTable[args.modMenueTable].getButtonInfo do
		local pageSideTable = g_currentMission.guiMenue.modTable[args.modMenueTable].getButtonInfo[a];
		if pageSideTable[args.name] ~= nil and args.masterPage == nil and args.slavePage == nil and args.pageSide == nil and args.pageSideGlobalName == nil and args.pageGlobalName == nil then --return first found returnClick name (is double then first :-( better check then with pageGlobalName or)
			setButtonInfoTable(pageSideTable[args.name]);			
			break;
		end;		
		if pageSideTable[args.name] ~= nil then
			if args.masterPage == nil and args.slavePage == nil and args.pageSide ~= nil and type(args.pageSide) == "number" then
				if tonumber(args.pageSide) == tonumber(pageSideTable[args.name].pageSide) then
					if (args.pageGlobalName ~= nil and tostring(args.pageGlobalName) == pageSideTable[args.name].pageGlobalName) or (args.pageSideGlobalName ~= nil and tostring(args.pageSideGlobalName) == pageSideTable[args.name].pageSideGlobalName) or (args.pageGlobalName == nil and args.pageSideGlobalName == nil) then
						setButtonInfoTable(pageSideTable[args.name]);
						break;
					end;
				end;
			end;
			if args.masterPage ~= nil and type(args.masterPage) == "number" and tonumber(args.masterPage) == tonumber(pageSideTable[args.name].masterPage) then
				if args.slavePage == nil and args.pageSide ~= nil and type(args.pageSide) == "number" and tonumber(args.pageSide) == tonumber(pageSideTable[args.name].pageSide) then
					if (args.pageGlobalName ~= nil and tostring(args.pageGlobalName) == pageSideTable[args.name].pageGlobalName) or (args.pageSideGlobalName ~= nil and tostring(args.pageSideGlobalName) == pageSideTable[args.name].pageSideGlobalName) or (args.pageGlobalName == nil and args.pageSideGlobalName == nil) then
						setButtonInfoTable(pageSideTable[args.name]);
						break;
					end;
				end;
				if args.slavePage ~= nil and type(args.slavePage) == "number" and pageSideTable[args.name].slavePage ~= nil and args.pageSide ~= nil and type(args.pageSide) == "number" and tonumber(args.slavePage) == tonumber(pageSideTable[args.name].slavePage) and tonumber(args.pageSide) == tonumber(pageSideTable[args.name].pageSide) then				
					if (args.pageGlobalName ~= nil and tostring(args.pageGlobalName) == pageSideTable[args.name].pageGlobalName) or (args.pageSideGlobalName ~= nil and tostring(args.pageSideGlobalName) == pageSideTable[args.name].pageSideGlobalName) or (args.pageGlobalName == nil and args.pageSideGlobalName == nil) then
						setButtonInfoTable(pageSideTable[args.name]);
						break;
					end;
				end;
				if args.slavePage ~= nil and type(args.slavePage) == "number" and pageSideTable[args.name].slavePage ~= nil and tonumber(args.slavePage) == tonumber(pageSideTable[args.name].salvePage) then
					if (args.pageGlobalName ~= nil and tostring(args.pageGlobalName) == pageSideTable[args.name].pageGlobalName) or (args.pageSideGlobalName ~= nil and tostring(args.pageSideGlobalName) == pageSideTable[args.name].pageSideGlobalName) or (args.pageGlobalName == nil and args.pageSideGlobalName == nil) then
						setButtonInfoTable(pageSideTable[args.name]);
						break;
					end;					
				end;				
			end;
			if args.masterPage == nil then
				if args.slavePage == nil and args.pageSide ~= nil and type(args.pageSide) == "number" and tonumber(args.pageSide) == tonumber(pageSideTable[args.name].pageSide) then
					if (args.pageGlobalName ~= nil and tostring(args.pageGlobalName) == pageSideTable[args.name].pageGlobalName) or (args.pageSideGlobalName ~= nil and tostring(args.pageSideGlobalName) == pageSideTable[args.name].pageSideGlobalName) or (args.pageGlobalName == nil and args.pageSideGlobalName == nil) then
						setButtonInfoTable(pageSideTable[args.name]);
						break;
					end;
				end;
				if args.slavePage ~= nil and type(args.slavePage) == "number" and pageSideTable[args.name].slavePage ~= nil and args.pageSide ~= nil and type(args.pageSide) == "number" and tonumber(args.slavePage) == tonumber(pageSideTable[args.name].slavePage) and tonumber(args.pageSide) == tonumber(pageSideTable[args.name].pageSide) then				
					if (args.pageGlobalName ~= nil and tostring(args.pageGlobalName) == pageSideTable[args.name].pageGlobalName) or (args.pageSideGlobalName ~= nil and tostring(args.pageSideGlobalName) == pageSideTable[args.name].pageSideGlobalName) or (args.pageGlobalName == nil and args.pageSideGlobalName == nil) then
						setButtonInfoTable(pageSideTable[args.name]);
						break;
					end;
				end;
			end;				
		end;
	end;	
	return newTable;
end;

function guiSetGet:modSaveButtonInfo(mod, reset) --sort/save button list info byName(returnClick), (line,page,side,button position) for a Mod and returnClick Name
	local modTable = g_currentMission.guiMenue.modTable[mod];
	if reset then g_currentMission.guiMenue.modTable[mod].getButtonInfo = {};end;
	if modTable ~= nil then
		--search masterPage/Side
		for page=1, #modTable.page do
			if modTable.page[page].side ~= nil and #modTable.page[page].side > 0 then
				for side=1, #modTable.page[page].side do
					if modTable.page[page].side[side].line ~= nil and #modTable.page[page].side[side].line > 0 then
						for line=1, #modTable.page[page].side[side].line do
							if modTable.page[page].side[side].line[line] ~= nil and #modTable.page[page].side[side].line[line].button > 0 then
								for button=1, #modTable.page[page].side[side].line[line].button do
									g_currentMission.guiMenue.modTable[mod].getButtonInfo[#g_currentMission.guiMenue.modTable[mod].getButtonInfo+1] = {};
									buttonTable = #g_currentMission.guiMenue.modTable[mod].getButtonInfo;																	
									g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].side[side].line[line].button[button].returnClick] = {};
									g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].side[side].line[line].button[button].returnClick].button = button;
									g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].side[side].line[line].button[button].returnClick].line = line;
									g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].side[side].line[line].button[button].returnClick].pageSide = side;
									g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].side[side].line[line].button[button].returnClick].page = page;
									g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].side[side].line[line].button[button].returnClick].pageGlobalName = modTable.page[page].globalName or "";
									g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].side[side].line[line].button[button].returnClick].pageSideGlobalName = modTable.page[page].side[side].globalName or "";									
									g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].side[side].line[line].button[button].returnClick].masterPage = page;									
								end;
							end;
						end;
					end;
				end;
			end;
		end;
		--search masterPage/Side
		--search slavePage/Side
		for page=1, #modTable.page do
			if modTable.page[page].page ~= nil and #modTable.page[page].page > 0 then
				for slavePage=1, #modTable.page[page].page do					
					if modTable.page[page].page[slavePage].side ~= nil and #modTable.page[page].page[slavePage].side > 0 then
						for side=1, #modTable.page[page].page[slavePage].side do
							if modTable.page[page].page[slavePage].side[side].line ~= nil and #modTable.page[page].page[slavePage].side[side].line > 0 then
								for line=1, #modTable.page[page].page[slavePage].side[side].line do
									if modTable.page[page].page[slavePage].side[side].line[line] ~= nil and #modTable.page[page].page[slavePage].side[side].line[line].button > 0 then
										for button=1, #modTable.page[page].page[slavePage].side[side].line[line].button do
											g_currentMission.guiMenue.modTable[mod].getButtonInfo[#g_currentMission.guiMenue.modTable[mod].getButtonInfo+1] = {};
											buttonTable = #g_currentMission.guiMenue.modTable[mod].getButtonInfo;
											g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].page[slavePage].side[side].line[line].button[button].returnClick] = {};
											g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].page[slavePage].side[side].line[line].button[button].returnClick].button = button;
											g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].page[slavePage].side[side].line[line].button[button].returnClick].line = line;
											g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].page[slavePage].side[side].line[line].button[button].returnClick].pageSide = side;
											g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].page[slavePage].side[side].line[line].button[button].returnClick].page = page;
											g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].page[slavePage].side[side].line[line].button[button].returnClick].pageGlobalName = modTable.page[page].page[slavePage].globalName or "";
											g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].page[slavePage].side[side].line[line].button[button].returnClick].pageSideGlobalName = modTable.page[page].page[slavePage].side[side].globalName or "";
											g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].page[slavePage].side[side].line[line].button[button].returnClick].slavePage = slavePage;
											g_currentMission.guiMenue.modTable[mod].getButtonInfo[buttonTable][modTable.page[page].page[slavePage].side[side].line[line].button[button].returnClick].masterPage = page;
										end;
									end;
								end;
							end;
						end;
					end;
					
				end;
			end;
		end;
		--search slavePage/Side
	end;
end;

local abs, ceil, floor, max, min, random, pow = math.abs, math.ceil, math.floor, math.max, math.min, math.random, math.pow;
function guiSetGet:round(n, precision)
	if precision and precision > 0 then
		return floor((n * pow(10, precision)) + 0.5) / pow(10, precision);
	end;
	return floor(n + 0.5);
end;

local targetAspectRatio = 16/9;
local aspectRatioRatio = g_screenAspectRatio / targetAspectRatio;
local sizeRatio = 1;
if g_screenWidth >= 1920 then
	sizeRatio = 1920 / g_screenWidth;
elseif g_screenWidth < 1920 then
	sizeRatio = max((1920 / g_screenWidth) * 0.75, 1);
end;

function guiSetGet:getFullPx(n, dimension)
	if dimension == 'x' then
		return guiSetGet:round(n * g_screenWidth) / g_screenWidth;
	else
		return guiSetGet:round(n * g_screenHeight) / g_screenHeight;
	end;
end;

function guiSetGet:pxToNormal(px, dimension, fullPixel)
	local ret;
	if dimension == 'x' then
		ret = (px / 1920) * sizeRatio;
		--ret = (px / g_screenWidth) * sizeRatio;
	else
		ret = (px / 1080) * sizeRatio * aspectRatioRatio;
		--ret = (px / g_screenHeight) * sizeRatio * aspectRatioRatio;
	end;
	if fullPixel == nil or fullPixel then
		ret = guiSetGet:getFullPx(ret, dimension);
	end;
	return ret;
end;

function guiSetGet:setBackgroundColor(overlay, color)
	if overlay ~= nil and overlay.overlayId then
		--local rC,gC,bC,aC = unpack(color);
		--overlay.r=rC or 1; overlay.g=gC or 1; overlay.b=bC or 1; overlay.a=aC or 1;
		--Overlay:setColor(unpack(color), overlay.overlayId)--, unpack(color));
		setOverlayColor(overlay.overlayId, unpack(color));
	end;
end;

function guiSetGet:resetOverlay(self, overlay)
	guiSetGet:setOverlay(self, overlay, 0, 0, 0, 0);	
end;

function guiSetGet:setOverlay(self, overlay, posX, posY, width, height, invertX, rotation, rotationX, rotationY)	
	if overlay ~= nil and overlay.overlayId then
		if width ~= nil then overlay.width = width;end;
		if height ~= nil then overlay.height = height;end;
		if posX ~= nil then overlay.x = posX;end;
		if posY ~= nil then overlay.y = posY;end;
		if invertX ~= nil and invertX then overlay.invertX = invertX;end;
		if rotation ~= nil and rotation then overlay.rotation = rotation;end;
		if rotationX ~= nil and rotationX then overlay.rotationCenterX = rotationX;end;
		if rotationY ~= nil and rotationY then overlay.rotationCenterY = rotationY;end;
		--overlay:setPosition(posX, posY);end;
	end;
end;

function guiSetGet:getOverlay(self, overlay)	
	if overlay ~= nil and overlay.overlayId then
		return overlay.x, overlay.y, overlay.width, overlay.height;			
	end;
	return nil;
end;

function guiSetGet:setOverlayUVsPx(overlay, UVs, textureSizeX, textureSizeY)	
	if overlay.overlayId and overlay.currentUVs == nil or overlay.currentUVs ~= UVs then
		local leftX, bottomY, rightX, topY = unpack(UVs);
		local fromTop = false;
		if topY < bottomY then
			fromTop = true;
		end;
		local leftXNormal = leftX / textureSizeX;
		local rightXNormal = rightX / textureSizeX;
		local bottomYNormal = bottomY / textureSizeY;
		local topYNormal = topY / textureSizeY;
		if fromTop then
			bottomYNormal = 1 - bottomYNormal;
			topYNormal = 1 - topYNormal;
		end;
		--overlay.uvs = {};
		--overlay.uvs[1]=leftXNormal; overlay.uvs[2]=bottomYNormal; overlay.uvs[3]=leftXNormal; overlay.uvs[4]=topYNormal; overlay.uvs[5]=rightXNormal; overlay.uvs[6]=bottomYNormal; overlay.uvs[7]=rightXNormal; overlay.uvs[8]=topYNormal;
		--overlay.uvs[1]={leftXNormal}; overlay.uvs[2]={bottomYNormal}; overlay.uvs[3]={leftXNormal}; overlay.uvs[4]={topYNormal}; overlay.uvs[5]={rightXNormal}; overlay.uvs[6]={bottomYNormal}; overlay.uvs[7]={rightXNormal}; overlay.uvs[8]={topYNormal};
		
		setOverlayUVs(overlay.overlayId, leftXNormal,bottomYNormal, leftXNormal,topYNormal, rightXNormal,bottomYNormal, rightXNormal,topYNormal);		
		--overlay.uvs = {leftXNormal,bottomYNormal, leftXNormal,topYNormal, rightXNormal,bottomYNormal, rightXNormal,topYNormal};
		overlay.currentUVs = UVs;
	end;
end;

function guiSetGet:deleteOldOverlay(overlay)
	if overlay ~= nil and overlay and overlay.overlayId ~= nil and overlay.overlayId then
		overlay:delete();
		overlay = nil;		
	end;
end;

function guiSetGet:checkDesignFilePath()	
	local iconFilePath = Utils.getFilename("guiMenue/menueDesign.dds", guiMenue.modDir );			
	if not fileExists(iconFilePath) then		
		iconFilePath = nil;				
	end;
	return iconFilePath;
end;

guiSetGet.colors = {		
	darkYellow =   		{ 255/255, 161/255,  17/255, 1.00 };
	darkYellowOff =  	{ 255/255, 161/255,  17/255, 0.80 };
	white =         	{ 255/255, 255/255, 255/255, 1.00 };
	whiteBestPrice =	{ 255/255, 255/255, 255/255, 1.00 };
	whiteInactive = 	{ 255/255, 255/255, 255/255, 0.75 };
	whiteDisabled = 	{ 255/255, 255/255, 255/255, 0.15 };
	hover =         	{   4/255,  98/255, 180/255, 1.00 };
	hoverBestPrice =	{   4/255,  98/255, 180/255, 0.70 };
	darkBlue =	 		{ 	0/255,   0/255, 255/255, 1.00 };
	activeGreen =   	{  43/255, 205/255,  10/255, 1.00 }; 
	activeRed =    	 	{ 153/255,  22/255,  19/255, 1.00 }; 
	closeRed =      	{ 116/255,   0/255,   0/255, 1.00 }; 
	warningRed =    	{ 222/255,   2/255,   3/255, 1.00 };
	red =      			{ 255/255,   0/255,   0/255, 1.00 };
	redDisabled =   	{ 255/255,   0/255,   0/255, 0.80 };
	shadow =        	{   4/255,   4/255,   4/255, 1.00 }; 
	textDark =      	{   1/255,   1/255,   1/255, 1.00 };
	yellow =        	{ 255/255, 255/255,   0/255, 1.00 };
	yellowDisabled =	{ 255/255, 255/255,   0/255, 0.80 };
	yellowGreen =		{ 154/255, 205/255,  50/255, 1.00 };
	yellow1 =			{ 238/255, 221/255, 130/255, 1.00 };
	gold =				{ 255/255, 215/255,   0/255, 1.00 };
	green =        		{ 	0/255, 255/255,   0/255, 1.00 };
	darkOliveGreen =    {  85/255, 107/255,  47/255, 1.00 };
	greenDisabled = 	{ 	0/255, 255/255,   0/255, 0.80 };
	greenMatt		 = 	{ 	0/255, 255/255,   0/255, 0.30 };
	darkGreen = 		{ 	0/255, 100/255,   0/255, 1.00 };
	lightGreen =   		{ 144/255, 238/255, 144/255, 1.00 };
	chartreuse4 =		{ 69/255,  139/255,   0/255, 1.00 };
	happylooser =   	{ 143/255, 188/255, 143/255, 1.00 };---
	happylooserOff= 	{ 143/255, 188/255, 143/255, 0.80 };---
	gray = 				{ 190/255, 190/255, 190/255, 1.00 };
	grayInactive = 		{ 190/255, 190/255, 190/255, 0.10 };
	black =        		{ 	0/255,   0/255,   0/255, 1.00 };
	blackDisabled = 	{ 	0/255, 	 0/255,   0/255, 0.85 };
	blackInactive = 	{ 	0/255, 	 0/255,   0/255, 0.15 };
	orange =        	{ 255/255, 165/255,   0/255, 1.00 };
	orangeRed =        	{ 255/255,  55/255,   0/255, 1.00 };
	khaki =         	{ 240/255, 230/255, 140/255, 1.00 };
	ls15 =          	{   0/255, 255/255, 255/255, 1.00 };
	ls15Disabled =  	{   0/255, 255/255, 255/255, 0.80 };
	mangenta =  		{ 255/255, 	 0/255, 255/255, 1.00 };
	deepPink =  		{ 255/255, 020/255, 147/255, 1.00 };
	purple =  			{ 160/255, 032/255, 240/255, 1.00 };
};

function guiSetGet:addTimer()
	if g_currentMission.guiMenue.timers == nil then g_currentMission.guiMenue.timers = {};end;
	for a=1, 60 do -- 1-60 sec Timer
		g_currentMission.guiMenue.timers[tostring(a).. "sec"] = {current_time = 0, delay = a*1000, onOff = true, action = nil, repeatable = true, runs=true};
	end;
	for a=1, 60 do -- 1-60 Milli-sec Timer
		g_currentMission.guiMenue.timers[tostring(a).. "mSec"] = {current_time = 0, delay = a*100, onOff = true, action = nil, repeatable = true, runs=true};
	end;
end;

function guiSetGet:update_timers(dt)
	if g_currentMission.guiMenue.timers ~= nil then
		for name, timer in pairs(g_currentMission.guiMenue.timers) do
			if g_currentMission.guiMenue.timers[name] ~= nil then --for delete -timer check
				timer.current_time = timer.current_time + dt;
				if timer.current_time > timer.delay then
					if timer.onOff then timer.onOff = false;else timer.onOff = true;end; --onOff 1xon 1xoff all ..sec
					timer.runs = false; --1x all ..sec, blink effect oder auslöser								 
					if timer.action then timer.action();end;            
					if timer.repeatable then 
						if type(timer.repeatable) == "number" then
							timer.repeatable = timer.repeatable - 1
							if timer.repeatable >= 0 then 
								timer.current_time = 0;							
							else 
								g_currentMission.guiMenue.timers[name] = nil; 
							end;
						else 
							timer.current_time = 0;						
						end;
					else
						g_currentMission.guiMenue.timers[name] = nil;
					end;
				else
					timer.runs = true;
				end;
			end;
		end;
	end;
end;

function guiSetGet:runsTimer(name, onOff)
	if name == nil or type(name) ~= "string" then return nil;end;
	if g_currentMission.guiMenue.timers ~= nil and g_currentMission.guiMenue.timers[name] ~= nil then		
		if onOff ~= nil and onOff then
			return g_currentMission.guiMenue.timers[name].onOff, g_currentMission.guiMenue.timers[name].repeatable;
		else
			return g_currentMission.guiMenue.timers[name].runs, g_currentMission.guiMenue.timers[name].repeatable;
		end;
	end;
	return nil;
end;

function guiSetGet:getAllowedCharacters()
	local allowedSpan = { from = 32, to = 591 };
	local prohibitedUnicodes = { [34] = true, [39] = true, [94] = true, [96] = true, [215] = true, [247] = true };
	for unicode=127,190 do
		prohibitedUnicodes[unicode] = true;
	end;
	local result = {};
	for unicode=allowedSpan.from,allowedSpan.to do
		prohibitedUnicodes[unicode] = prohibitedUnicodes[unicode] or false;
		result[unicode] = not prohibitedUnicodes[unicode] and getCanRenderUnicode(unicode);
		--if getCanRenderUnicode(unicode) then
			--print(string.format('allowedCharacters[%d]=%s (%q) (prohibited=%s, getCanRenderUnicode()=true)', unicode, tostring(result[unicode]), unicodeToUtf8(unicode), tostring(prohibitedUnicodes[unicode])));
			--print("-unicode:".. unicode, "-result:".. tostring(result[unicode]), "-unicodeToUtf8:".. unicodeToUtf8(unicode), "-prohibited..:".. tostring(prohibitedUnicodes[unicode]));
		--end;
	end;
	return result;
end;

function guiSetGet:getUtf8normalization()
	local result = {};
	local normalizationSpans = {
		a  = { {192,195}, 197, {224,227}, 229, {256,261} },
		ae = { 196, 198, 228, 230 },
		c  = { 199, 231, {262,269} },
		d  = { {270,273} },
		e  = { {200,203}, {232,235}, {274,283} },
		g  = { {284,291} },
		h  = { {292,295} },
		i  = { {204,207}, {236,239}, {296,307} },
		j  = { {308,309} },
		k  = { {310,312} },
		l  = { {313,322} },
		n  = { 209, 241, {323,331} },
		o  = { {210,213}, {242,245}, {332,337} },
		oe = { 214, 216, 246, 248, 338, 339 },
		r  = { {340,345} },
		s  = { {346,353}, 383 },
		ss = { 223 },
		t  = { {354,359} },
		u  = { {217,219}, {249,251}, {360,371} },
		ue = { 220, 252 },
		w  = { 372, 373 },
		y  = { 221, 253, 255, {374,376} },
		z  = { {377,382} }
	};
	for normal,unicodes in pairs(normalizationSpans) do
		for _,data in pairs(unicodes) do
			if type(data) == "number" then
				local utf8 = unicodeToUtf8(data);
				result[utf8] = normal;
				if false and getCanRenderUnicode(data) then
					--print(string.format("MultiOverlayV3.utf8normalization[%q] = %q", utf8, normal));
				end;
			elseif type(data) == "table" then
				for unicode=data[1],data[2] do
					local utf8 = unicodeToUtf8(unicode);
					result[utf8] = normal;
					if false and getCanRenderUnicode(unicode) then
						--print(string.format("MultiOverlayV3.utf8normalization[%q] = %q", utf8, normal));
					end;
				end;
			end;
		end;
	end;
	return result;
end;

function guiSetGet:onIsUnicodeAllowed(unicode)
	return g_currentMission.guiMenue.allowedCharacters[unicode] == true;
end;