moFillTypeMoversConfig = {};

function moFillTypeMoversConfig:onStartMission()	
	moFillTypeMovers:load();
end;

function moFillTypeMoversConfig:defaultValues()
	moFillTypeMovers.values = {factorys={}, updateTimer=60, msec=false};
end;

function moFillTypeMoversConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moFillTypeMovers.values == nil then moFillTypeMoversConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.filltypemovers(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		moFillTypeMovers.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	end;
	if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		moFillTypeMovers.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	end;
end;

function moFillTypeMoversConfig:saveXml(self, Xml, xmlNameTag)
	if moFillTypeMovers.values == nil then moFillTypeMoversConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.filltypemovers(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moFillTypeMovers.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moFillTypeMovers.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moFillTypeMoversConfig.onSaveCallback()
	moSetGetClientSettings:saveConfig(self)
end;